<template>
  <v-card class="pt-4">
    <v-card-text>
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-row class="mt-3">
          <v-col align="center">
            <h2>Incio</h2>
          </v-col>
          <v-col align="center">
            <h2>Fin</h2>
          </v-col>
        </v-row>
        <v-row class="my-3" justify="center">
          <v-col align="center">
            <v-date-picker v-model="desde" color="accent" />
          </v-col>
          <v-col align="center">
            <v-date-picker v-model="hasta" color="accent" required />
          </v-col>
        </v-row>
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Descargar
      </v-btn>
    </v-card-actions>
    <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
  </v-card>
</template>

<script lang="ts">
import { Component, Ref, Vue } from 'vue-property-decorator'

import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { App } from '~/core/App'
import UpWebView from '~/components/shared/UpWebView.vue'
@Component({
  components: { UpWebView }
})
export default class filtroPeriodo extends Vue {
  @Ref('form') formulario;

  desde = null;
  hasta = null;
  showDialogPDF:boolean = false;
  urlPDF:string = '';

  rules = {
    nombre: [
      v => !!v || 'Campo requerido'
    ]
  };

  cerrarDialog () {
    this.$emit('onClose')
  }

  validarFormulario () {
    if (this.formulario.validate()) {
      if (this.desde === null) {
        AppToast.error('Por favor seleccione la fecha de inicio')
      } else if (this.hasta === null) {
        AppToast.error('Por favor seleccione la fecha de fin')
      } else {
        this.imprimirFiltro()
      }
    } else {
      AppToast.error('Campos inválidos')
    }
  }

  imprimirFiltro () {
    const f = {
      fecha1: this.desde,
      fecha2: this.hasta
    }

    AppStore.SHOW_LOADING('Descargando datos...')

    const url = 'comprobantes/turnos'
    App.$axios.get(url, {
      headers: { Accept: 'application/json' },
      params: f,
      responseType: 'blob'
    }).then((res) => {
      const data: Blob = res.data
      this.urlPDF = window.URL.createObjectURL(data)
      this.showDialogPDF = true
    }).catch(() => {
      AppToast.error('Hubo un error al descargar los datos para imprimir')
    }).finally(() => {
      AppStore.HIDE_LOADING()
    })
  }
}
</script>

<style lang="scss">

</style>
